# -*- coding: utf-8 -*-

# PyPreTeX - a Pythonic Previewer for LaTeX
# (c) 2007 Alexandre Erwin Ittner <alexandre@ittner.com.br>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston,
# MA 02111-1307, USA.

"""
Utility functions.
"""
import random
import os

import pygtk
import gtk
from gtk import gdk


def get_home_dir():
    return os.path.expanduser('~')


def search_share_path(fname):
    #TODO: Fix hardcoded paths.
    prefixes = ['', 'usr/share/pypretex/', 'usr/local/share/pypretex/']
    for prefix in prefixes:
        if os.path.exists(prefix + fname):
            return prefix + fname;
    for prefix in prefixes:
        if os.path.exists('/' + prefix + fname):
            return '/' + prefix + fname;
    return None


def confirm_yes_no(parent_window, msg):
    """A simple Yes/No message box.
    """
    dlg = gtk.MessageDialog(parent_window,
        gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
        gtk.MESSAGE_QUESTION, gtk.BUTTONS_YES_NO, msg)
    ret = dlg.run()
    dlg.destroy()
    return ret == gtk.RESPONSE_YES


def confirm_file_overwrite(parent_window, fpath):
    """A simple "Do you want to overwrite" message box.
    """
    fdir, fname = os.path.split(fpath)
    return confirm_yes_no(parent_window, u"The file " + fname + \
        u" already exists. Do you want to replace it?")


def error_dialog(parent_window, msg):
    """A simple error dialog box.
    """
    dlg = gtk.MessageDialog(parent_window,
        gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
        gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, msg)
    dlg.run()
    dlg.destroy()

